let pad = function(s) { if (s.length < 2) { return `0${s}`; } else { return s; } };

const sidBufferToString = (buf) =>{
  let asc, end;
  let i;
  if (buf == null) { return ''; }

  let version             = buf[0];
  let subAuthorityCount   = buf[1];
  let identifierAuthority = parseInt(((() => {
    let result = [];
    for (i = 2; i <= 7; i++) {
      result.push(buf[i].toString(16));
    }
    return result;
  })()).join(''), 16);

  let sidString = `S-${version}-${identifierAuthority}`;

  for (i = 0, end = subAuthorityCount-1, asc = 0 <= end; asc ? i <= end : i >= end; asc ? i++ : i--) {
    let subAuthOffset = i * 4;
    let tmp =
      pad(buf[11 + subAuthOffset].toString(16)) +
      pad(buf[10 + subAuthOffset].toString(16)) +
      pad(buf[9  + subAuthOffset].toString(16)) +
      pad(buf[8  + subAuthOffset].toString(16));
    sidString += `-${parseInt(tmp, 16)}`;
  }

  return sidString;
};

const sidBinToString = (bin) => {
  if( bin===undefined || bin.value === undefined )
    return '';
  const buf = Buffer.from(bin.value, 'base64');
  return sidBufferToString(buf);
}

module.exports = {
  sidBufferToString,
  sidBinToString
}