const base64js = require('base64-js');
const xml2js = require('xml2js');

const XMLtoJSON = ({ xml }) => {
    return new Promise((resolve, reject) => {
        xml2js.parseString(xml, function (err, result) {
            err ? reject(err) : resolve(result)
        });
    })
}

const ImportFromXmlToJson = async () => {
    try {
        const fileService = await runtime.get('services.file');
        const files = await fileService.upload({ accept: '.xml' });
        const b64 = await fileService.toBase64(files[0]);
        const bytes = base64js.toByteArray(b64);
        let text = new TextDecoder('utf-8').decode(bytes);
        text = text.replace("\ufeff", "");
        return await XMLtoJSON({xml:text});
    }
    catch (error) {
    }
    return {};
}

const ImportFromTxtToArray = async () => {
    try {
        const fileService = await runtime.get('services.file');
        const files = await fileService.upload({ accept:'.txt' });
        const b64 = await fileService.toBase64(files[0]);
        const bytes = base64js.toByteArray(b64);
        const text = new TextDecoder('utf-8').decode(bytes);
        return text.split('\n');
    }
    catch (error) {
    }

    return [];
}

module.exports = {
    ImportFromXmlToJson,
    ImportFromTxtToArray
}