
const VerdictTypeLocs = {
    1: 'VerdictTypes.Undefined',
    2: 'VerdictTypes.Virware',
    3: 'VerdictTypes.Trojware',
    4: 'VerdictTypes.Malware',
    5: 'VerdictTypes.Adware',
    6: 'VerdictTypes.Pornware',
    7: 'VerdictTypes.Riskware',
    8: 'VerdictTypes.Vulnerability'
};

const OasActionTypeLocs = {
    1: 'scanAction.block_cure',
    2: 'scanAction.block_delete',
    3: 'scanAction.recommended',
    4: 'scanAction.block',
    5: 'scanAction.block_quarantine',
    7: 'scanAction.skip',
    8: 'scanAction.notify',
};

const OasSecondActionTypeLocs = {
    2: 'scanAction.delete',
    4: 'scanAction.skip',
    5: 'scanAction.quarantine'
};

const OdsActionTypeLocs = {
    1: 'scanAction.cure',
    2: 'scanAction.delete',
    3: 'scanAction.recommended',
    4: 'scanAction.notify',
    5: 'scanAction.quarantine',
    7: 'scanAction.skip',
};

const NetAppActionTypeLocs = {
    1: 'scanAction.cure',
    2: 'scanAction.delete',
    4: 'scanAction.skip',
    5: 'scanAction.quarantine',
};

const OasAreaTypeLocs = {
    1: 'scanObjectType.myComputer',
    5: 'scanObjectType.fixed',
    6: 'scanObjectType.removable',
    7: 'scanObjectType.netDrives',
    8: 'scanObjectType.startup',
    9: 'scanObjectType.memory',
    10:'scanObjectType.shared'
};

const OdsAreaTypeLocs = {
    1: 'scanObjectType.myComputer',
    5: 'scanObjectType.fixed',
    6: 'scanObjectType.removable',
    8: 'scanObjectType.startup',
    9: 'scanObjectType.memory',
    10:'scanObjectType.shared',
    1000:'scanObjectType.quarantine'
};

const GetOasAreaTypeLoc = (type, defValue) => {
    if(type===undefined)
        return '';
    return OasAreaTypeLocs[type]!==undefined ? OasAreaTypeLocs[type] : defValue;
}

const GetOdsAreaTypeLoc = (type, defValue) => {
    if(type===undefined)
        return '';
    return OdsAreaTypeLocs[type]!==undefined ? OdsAreaTypeLocs[type] : defValue;
}

const GetOasActionTypeLocs = (type) => {
    if(type===undefined)
        return '';
    return OasActionTypeLocs[type]!==undefined ? OasActionTypeLocs[type] : type.toString();
}

const GetOasSecondActionTypeLocs = (type) => {
    if(type===undefined)
        return '';
    return OasSecondActionTypeLocs[type]!==undefined ? OasSecondActionTypeLocs[type] : type.toString();
}

const GetOdsActionTypeLocs = (type) => {
    if(type===undefined)
        return '';
    return OdsActionTypeLocs[type]!==undefined ? OdsActionTypeLocs[type] : type.toString();
}

const GetNetAppActionTypeLocs = (type) => {
    if(type===undefined)
        return '';
    return NetAppActionTypeLocs[type]!==undefined ? NetAppActionTypeLocs[type] : type.toString();
}

const GetVerdictLoc = (verdict) => {
    if(verdict===undefined)
        return '';
    return VerdictTypeLocs[verdict]!==undefined ? VerdictTypeLocs[verdict] : verdict.toString();
}

module.exports = {
    GetOasAreaTypeLoc,
    GetOdsAreaTypeLoc,
    GetOasActionTypeLocs,
    GetOasSecondActionTypeLocs,
    GetOdsActionTypeLocs,
    GetNetAppActionTypeLocs,
    GetVerdictLoc,
}