const lo = require('lodash');
const hlpSch = require('./TaskScheduleHelper.js')

const defPolicySections = []
const formValues = ['CollectInfoAboutOfflineDevices','UseHostInfoInFileName','UseExportGeneratedRulesToFile',
    'ExportGeneratedRulesToFile','AppendResultToDevControlRules']

function toView (TASK_ADDITIONAL_PARAMS, activePolicyCache, formType, isGroupTask, isLocked) {
    if(formType === 'Schedule' ) {
        return hlpSch.toView(TASK_ADDITIONAL_PARAMS.Schedule)
    }
    if(formType === 'Main' ) {
        const sett = TASK_ADDITIONAL_PARAMS.Settings;
        return {
            Form_DeviceRuleGenerator_Local_Common: {
                CollectInfoAboutOfflineDevices: sett.CollectInfoAboutOfflineDevices,
                UseHostInfoInFileName: sett.UseHostInfoInFileName,
                UseExportGeneratedRulesToFile: sett.UseExportGeneratedRulesToFile,
                ExportGeneratedRulesToFile: sett.ExportGeneratedRulesToFile,
                AppendResultToDevControlRules: sett.AppendResultToDevControlRules,
                RulesAddingStrategyType: sett.RulesAddingStrategyToDeviceControl.RulesAddingStrategyType,
                isTaskLocked: isLocked
            }
        }
    }
    return {}
}

function toRaw (TASK_ADDITIONAL_PARAMS, changedData, formType) {
    if(formType === 'Schedule' ) {
        hlpSch.toRaw(changedData, TASK_ADDITIONAL_PARAMS.Schedule);
        return;
    }
    Object.assign(TASK_ADDITIONAL_PARAMS.Settings, lo.pick(changedData.Form_DeviceRuleGenerator_Local_Common, formValues));
    Object.assign(TASK_ADDITIONAL_PARAMS.Settings.RulesAddingStrategyToDeviceControl.RulesAddingStrategyType, changedData.Form_DeviceRuleGenerator_Local_Common.RulesAddingStrategyType);
}

module.exports = {
    defPolicySections,
    toView,
    toRaw
};
