const lo = require('lodash');
const hlp = require('../../../helpers')
const hlpPolicy = require('../../../helpers_policy');
const hlpSch = require('./TaskScheduleHelper.js')

const defPolicySections = ['FirewallPolicy','PredefinedTasksPolicy']
const formAppRules = ['ApplicationRules']
const formPortRules = ['OpenPorts']

function toView(TASK_ADDITIONAL_PARAMS, activePolicyCache, formType) {
    if(formType === 'Schedule' ) {
        return hlpSch.toView(TASK_ADDITIONAL_PARAMS.Schedule, activePolicyCache.PredefinedTasksPolicy.FirewallStartOptions);
    }
    if(formType!=='Main')
        return {}

    let data = {
        Form_Network_FirewallAppRules: hlp.localSettingsToView(TASK_ADDITIONAL_PARAMS.Settings,activePolicyCache.FirewallPolicy,formAppRules),
        Form_Network_FirewallPortRules: hlp.localSettingsToView(TASK_ADDITIONAL_PARAMS.Settings,activePolicyCache.FirewallPolicy,formPortRules)
    }
    data.Form_Network_FirewallAppRules.LocalTask = true;
    data.Form_Network_FirewallPortRules.LocalTask = true;
    return data
}

function toRaw(TASK_ADDITIONAL_PARAMS, changedData, formType) {
    if(formType === 'Schedule' ) {
        hlpSch.toRaw(changedData, TASK_ADDITIONAL_PARAMS.Schedule);
        return;
    }
    else if(formType==='Main') {
        const Apps = hlp.ItemToLocalSettings(changedData.Form_Network_FirewallAppRules);
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings, lo.pick(Apps, formAppRules));
        const Ports = hlp.ItemToLocalSettings(changedData.Form_Network_FirewallPortRules);
        Object.assign(TASK_ADDITIONAL_PARAMS.Settings, lo.pick(Ports, formPortRules));
    }
}

function RbacToPolicyCache(activePolicyCache){
    const allFields = formAppRules.concat(formPortRules);
    activePolicyCache.FirewallPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.FirewallPolicy, allFields);
    activePolicyCache.PredefinedTasksPolicy = hlpPolicy.SetPolicyFieldsRbacLocked(activePolicyCache.PredefinedTasksPolicy, ['FirewallStartOptions']);
    return activePolicyCache;
}

module.exports = {
    defPolicySections,
    toView,
    toRaw,
    RbacToPolicyCache
};
