const lo = require('lodash');
const utilsTz = require('../../../utils/tz.js');

const sections = ['TrustedZonePolicy'];
const formTrustProcs = ['TrustAllBackupReadOperations', 'TrustedProcessesEnabled', 'TrustedProcesses'];

function toView (policiesCache) {
    const tzProfile = policiesCache.TrustedZonePolicy.Policy.KLPRSS_Val;
    const data = {
        Form_TrustedZones_Exclusions : {
            ExclutionRules : utilsTz.toViewExcludes(tzProfile.ExclutionRules),
            isExclutionsEditable : tzProfile.ExclutionRules.KLPRSS_ValLck ? false : true
        },
        Form_TrustedZones_Processes: {
            TrustAllBackupReadOperations: tzProfile.TrustAllBackupReadOperations,
            TrustedProcessesEnabled: tzProfile.TrustedProcessesEnabled,
            TrustedProcesses: utilsTz.toViewTrustedProcesses(tzProfile.TrustedProcesses),
        }
    };
    return data;
}

function toRaw (changedData, policiesCache) {
    const exclusionRules = utilsTz.toRowExcludes(changedData.Form_TrustedZones_Exclusions.ExclutionRules);
    Object.assign( policiesCache.TrustedZonePolicy.Policy.KLPRSS_Val.ExclutionRules, exclusionRules);
    changedData.Form_TrustedZones_Processes.TrustedProcesses = utilsTz.toRowTrustedProcesses(changedData.Form_TrustedZones_Processes.TrustedProcesses);
    Object.assign(policiesCache.TrustedZonePolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_TrustedZones_Processes, formTrustProcs) )
}

module.exports = {
    sections,
    toView,
    toRaw
};
