const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['WebTrafficMonitorPolicy']
const formValues = ['ControlledPorts', 'UsePortMode']

function toView (policiesCache) {
    let data = hlp.customToView(policiesCache.WebTrafficMonitorPolicy.Policy.KLPRSS_Val, formValues)
    data.uiFields = {Ports:[]}
    for(let node of data.ControlledPorts.KLPRSS_Val[0]){
        data.uiFields.Ports.push({Port:node})
    }

    return data
}

function toRaw (changedData, policiesCache) {
    let controlledPorts = []
    for(let node of changedData.uiFields.Ports){
        controlledPorts.push(node.Port)
    }
    delete changedData.uiFields
    changedData.ControlledPorts.KLPRSS_Val[0] = controlledPorts
    Object.assign( policiesCache.WebTrafficMonitorPolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues))
}

module.exports = {
    sections,
    toView,
    toRaw
};
