const policyDef = require('../../../../default/policy.js');
const enums     = require('../../../../types');
const utilsRpt  = require('../../../utils/report.js');

const sections = ['ReportingPolicy'];

function GetPolicyCustomEvents(uiEvent) {
    let pEvents = [];
    if(uiEvent.useCustom===false)
        return pEvents;

    for(let event of uiEvent.events){
        let policyEvent = policyDef.defaultEventStoreSettingsEventParams();
        policyEvent.EventType.KLPRSS_Val = event.eventId;
        policyEvent.WriteToReports.KLPRSS_Val = event.log;
        policyEvent.WriteToEventLog.KLPRSS_Val = event.wel;
        pEvents.push(policyEvent);
    }
    return pEvents;
}

function toView (policiesCache) {
    const repRolicy = policiesCache.ReportingPolicy.Policy.KLPRSS_Val;

    let data = {
        currentComponent: enums.ReportingSectionEnum.FileMonitor,
        Components: utilsRpt.ComponentData,
        LockSetts: {}
    }
    Object.assign(data.LockSetts, repRolicy.FileMonitorEventsStoreSettings);
    delete data.LockSetts.KLPRSS_Val;

    for (let key in data.Components) {
        let customEvent = data.Components[key];
        if(repRolicy[customEvent.key]!==undefined && repRolicy[customEvent.key].KLPRSS_Val!==undefined) {
            const pcEvents = repRolicy[customEvent.key].KLPRSS_Val[0];
            utilsRpt.UpdateUiCustomEvent(customEvent, pcEvents);
        }
    }
    return data;
}

function toRaw (changedData, policiesCache) {
    let repRolicy = policiesCache.ReportingPolicy.Policy.KLPRSS_Val;

    for (let key in changedData.Components) {
        const customEvent = changedData.Components[key];
        Object.assign(repRolicy[customEvent.key], changedData.LockSetts);

        let pcEvents = repRolicy[customEvent.key].KLPRSS_Val[0];
        pcEvents.UseCustomEvents.KLPRSS_Val = customEvent.useCustom;
        if(customEvent.useCustom) {
            pcEvents.CustomEvents.KLPRSS_Val = GetPolicyCustomEvents(customEvent);
        }
        else{
            pcEvents.EventSeverity.KLPRSS_Val = (typeof customEvent.severity === 'string') ? parseInt(customEvent.severity) : customEvent.severity;
            pcEvents.CustomEvents.KLPRSS_Val = [];
        }
    }
    Object.assign(policiesCache.ReportingPolicy.Policy.KLPRSS_Val, repRolicy);
}

module.exports = {
    sections,
    toView,
    toRaw
};
