const policyConverters = {
// AppSettings node
    AppSettings: require('./AppSettings/Base.js'),
    AppSettings_Scalability: require('./AppSettings/Scalability.js'),
    AppSettings_Security: require('./AppSettings/Security.js'),
    AppSettings_Connection: require('./AppSettings/Connection.js'),
    AppSettings_SysTasks: require('./AppSettings/SysTasks.js'),
    AppSettings_TrustedZone: require('./AppSettings/TrustedZone.js'),
    AppSettings_MountDevice: require('./AppSettings/MountDevices.js'),
    AppSettings_Backup: require('./AppSettings/Backup.js'),
    AppSettings_Quarantine: require('./AppSettings/Quarantine.js'),
    AppSettings_HostBlocking: require('./AppSettings/HostBlocking.js'),
    AppSettings_ServiceRights: require('./AppSettings/ServiceRights.js'),
    AppSettings_UserRights: require('./AppSettings/UserRights.js'),
// Protection node
    Protection_Oas: require('./Protection/Oas.js'),
    Protection_KsnCommon: require('./Protection/KsnCommon.js'),
    Protection_KsnEula: require('./Protection/KsnEula.js'),
    Protection_KsnWz: require('./Protection/KsnWz.js'),
    Protection_KmpEula: require('./Protection/KmpEula.js'),
    Protection_KpsnEula: require('./Protection/KpsnEula.js'),
    Protection_TrafficSecurity: require('./Protection/TrafficSecurity.js'),
    Protection_TS_ControlledPorts: require('./Protection/TsControlledPorts.js'),
    Protection_TS_ExcludedPorts: require('./Protection/TsExcludedPorts.js'),
    Protection_TS_ExcludedIps: require('./Protection/TsExcludedIps.js'),
    Protection_TS_ExcludedProcs: require('./Protection/TsExcludedApps.js'),
    Protection_Aep: require('./Protection/Aep.js'),
//    Protection_AepCommon: require('./Protection/AepCommon.js'),
//    Protection_AepProcesses: require('./Protection/AepProcesses.js'),
    Protection_ScriptChecker: require('./Protection/ScriptChecker.js'),
// Control node
    Control_Pep: require('./Control/Pep.js'),
    Control_DevCtrlCommon: require('./Control/DevCtrlCommon.js'),
// Nas node
    Nas_NetApp: require('./Nas/NetApp.js'),
    Nas_Icap: require('./Nas/Icap.js'),
    Nas_AntiCrypt: require('./Nas/AntiCrypt.js'),
// Network node
    Firewall: require('./Network/Firewall.js'),
    NetworkAttackBlocker: require('./Network/AttackBlocker.js'),
    AntiCryptor: require('./Network/AntiCryptor.js'),
// SysInspect
    Fim_Common: require('./SysInspect/FimCommon.js'),
    LogInspector: require('./SysInspect/LogInspector.js'),
// Reporting node
    Reporting_Logs: require('./Reporting/Logs.js'),
    Reporting_LogJournals: require('./Reporting/LogJournals.js'),
    Reporting_SysLogs: require('./Reporting/SysLogs.js'),
    Reporting_Events: require('./Reporting/Events.js'),
    Reporting_Thresholds: require('./Reporting/Thresholds.js'),
    Reporting_NetList: require('./Reporting/NetList.js'),
// Schedule nodes
//    PolicySchedule_Rtp: require('./Schedule/oas.js'),
    PolicySchedule_Ksn: require('./Schedule/ksn.js')
}

module.exports = policyConverters
