const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['BackupSettings']
const formValues = ['StorePath','CheckSizeLimit','SizeLimit', 'CheckFreeSpaceThreshold', 'FreeSpaceThreshold']

function toView (settCache, activePolicyCache) {
    let data = hlp.localSettingsToView(settCache.BackupSettings,activePolicyCache.BackupSettings,formValues);
    data.RESTORE_PATH = hlp.GetMergedLocalSettingsKey(settCache.BackupSettings,activePolicyCache.BackupSettings,'RestorePath','RESTORE_PATH')
    data.LocalSettings=true
    return data
}

function toRaw (changedData, settCache) {
    hlp.ItemToLocalSettings(changedData);
    Object.assign(settCache.BackupSettings, lo.pick(changedData, formValues));
    settCache.BackupSettings.RestorePath = changedData.RESTORE_PATH;
}

module.exports = {
    sections,
    toView,
    toRaw
};
