const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['HostBlockingSettings']
const formValues = ['AutoBlockPeriod']

function toView (settCache, activePolicyCache) {
    let data = hlp.localSettingsToView(settCache.HostBlockingSettings,activePolicyCache.HostBlockingSettings,formValues);
    data.LocalSettings=true
    // convert minutes to days and hours
    const minutesToBlock = data.AutoBlockPeriod.KLPRSS_Val[0]
    data.days = parseInt(minutesToBlock / (24 * 60));
    data.hours = parseInt((minutesToBlock - (data.days * 24 * 60)) / 60);
    data.minutes = parseInt(minutesToBlock - (data.days * 24 * 60) - (data.hours * 60));
    return data
}

function toRaw (changedData, settCache) {
	let minutesToBlock = parseInt(changedData.days * 24 * 60 + changedData.hours * 60 + changedData.minutes);
    changedData.AutoBlockPeriod.KLPRSS_Val[0] = ( minutesToBlock < 1 ) ? 1 : minutesToBlock
    hlp.ItemToLocalSettings(changedData);
    Object.assign(settCache.HostBlockingSettings, lo.pick(changedData, formValues))
}

module.exports = {
    sections,
    toView,
    toRaw
};
