const taskDefs = require('../../default/tasks.js');
const utilsScan = require('../../common/utils_scan');

const toFormsOnDemand = (sett) => {
    let scanScopeUI = [];
    sett.ScanScope.forEach(function(item, index, array) {
        item.Enabled = true;
        item.uiFields = utilsScan.getOdsUIFields(item.ScanSettings);
        scanScopeUI.push(item);
    });

    sett.ExcludedFromScanScope.forEach(function(item, index, array) {
        item.Enabled = false;
        item.AreaDesc ='';
        item.ScanSettings = taskDefs.defaultOdsScanSettings();
        item.uiFields = utilsScan.getOdsUIFields(item.ScanSettings);
        scanScopeUI.push(item);
    });

    const data = {
        Form_OnDemand_ScanScope: {
            ScanScopeWithExcludes: scanScopeUI
        },
        Form_OnDemand_Options:{
            UseHeuristicAnalyzer: sett.UseHeuristicAnalyzer,
            HeuristicAnalyzerLevel: sett.HeuristicAnalyzerLevel,
            UseTrustedZoneSettings: sett.UseTrustedZoneSettings,
            UseLowPriorityProcess: sett.UseLowPriorityProcess,
            ScanCriticalAreasTaskFlag: sett.ScanCriticalAreasTaskFlag,
            UseKsn: sett.UseKsn
        }
    }
    return data;
}

function toFormsScanQuarantine(sett) {
    const scanScopeUI = [{
        AreaDesc: '',
        AreaName: '',
        AreaType:1000,
        Enabled: true
    }];
    let data = {
        Form_OnDemand_ScanScope: {
            ScanScopeWithExcludes: scanScopeUI
        },
        Form_OnDemand_Options:{
            UseHeuristicAnalyzer: sett.UseHeuristicAnalyzer,
            HeuristicAnalyzerLevel: sett.HeuristicAnalyzerLevel,
            UseTrustedZoneSettings: sett.UseTrustedZoneSettings,
            UseLowPriorityProcess: sett.UseLowPriorityProcess,
            ScanCriticalAreasTaskFlag: sett.ScanCriticalAreasTaskFlag,
            UseKsn: sett.UseKsn
        }
    }
    return data;
}

const fromFormsOnDemand = (changedData, sett) => {
    let scanScope = [];
    let scanExcludes = [];
    changedData.Form_OnDemand_ScanScope.ScanScopeWithExcludes.forEach(function(item, index, array) {
        item.__VersionInfo = [1, 0];
        if(true===item.Enabled ){
            item.ScanSettings = utilsScan.UIFieldsToOdsSettings(item.ScanSettings, item.uiFields);
            delete item.Enabled;
            delete item.uiFields;
            scanScope.push(item);
        }
        else{
            delete item.Enabled;
            delete item.uiFields;
            delete item.ScanSettings;
            delete item.AreaDesc;
            scanExcludes.push(item);
        }
    });

    sett.ScanScope = scanScope;
    sett.ExcludedFromScanScope = scanExcludes;

    sett.UseHeuristicAnalyzer = changedData.Form_OnDemand_Options.UseHeuristicAnalyzer;
    sett.HeuristicAnalyzerLevel = changedData.Form_OnDemand_Options.HeuristicAnalyzerLevel;
    sett.UseTrustedZoneSettings = changedData.Form_OnDemand_Options.UseTrustedZoneSettings;
    sett.UseLowPriorityProcess = changedData.Form_OnDemand_Options.UseLowPriorityProcess;
    sett.ScanCriticalAreasTaskFlag = changedData.Form_OnDemand_Options.ScanCriticalAreasTaskFlag;
    sett.UseKsn = changedData.Form_OnDemand_Options.UseKsn;
    return sett;
}

function fromFormsScanQuarantine(changedData, sett) {
    sett.UseHeuristicAnalyzer = changedData.Form_OnDemand_Options.UseHeuristicAnalyzer
    sett.HeuristicAnalyzerLevel = changedData.Form_OnDemand_Options.HeuristicAnalyzerLevel
    sett.UseTrustedZoneSettings = changedData.Form_OnDemand_Options.UseTrustedZoneSettings
    sett.UseLowPriorityProcess = changedData.Form_OnDemand_Options.UseLowPriorityProcess
    sett.ScanCriticalAreasTaskFlag = changedData.Form_OnDemand_Options.ScanCriticalAreasTaskFlag
    sett.UseKsn = changedData.Form_OnDemand_Options.UseKsn
    return sett;
}

module.exports = {
    toFormsOnDemand,
    toFormsScanQuarantine,
    fromFormsOnDemand,
    fromFormsScanQuarantine
}