const enums = require('../../types')

const ContentCategoryEnum = {
    0: {def:'Other', tags:'', loc:'ContentCategories.Other'},
    1: {def:'Porno', tags:'sex&adult; 18+', loc:'ContentCategories.Porno'},
    2: {def:'IllegalSoftware', tags:'IT; web services; media sharing', loc:'ContentCategories.IllegalSoftware'},
    3: {def:'Drugs', tags:'psychotropic&drug; 18+', loc:'ContentCategories.Drugs'},
    4: {def:'Violence', tags:'violence; 18+', loc:'ContentCategories.Violence'},
    5: {def:'Uncensored', tags:'18+', loc:'ContentCategories.Uncensored'},
    6: {def:'Weapons', tags:'society&law; 18+', loc:'ContentCategories.Weapons'},
    7: {def:'Gambling', tags:'hobby&entertainment; gaming - hazard', loc:'ContentCategories.Gambling'},
    8: {def:'ChatForum', tags:'hobby&entertainment; online collaboration', loc:'ContentCategories.ChatForum'},
    9: {def:'WebMail', tags:'web services; IT', loc:'ContentCategories.WebMail'},
    10:{def:'OnlineShops', tags:'shopping', loc:'ContentCategories.OnlineShops'},
    11:{def:'SocialNets', tags:'hobby&entertainment; online collaboration', loc:'ContentCategories.SocialNets'},
    12:{def:'JobSites', tags:'online collaboration', loc:'ContentCategories.JobSites'},
    13:{def:'AnonymousProxy', tags:'web services; IT', loc:'ContentCategories.AnonymousProxy'},
    14:{def:'CreditCards', tags:'money&paying', loc:'ContentCategories.CreditCards'},
    15:{def:'CasualGames', tags:'gaming; hobby&entertainment', loc:'ContentCategories.CasualGames'},
    16:{def:'PaymentSystems', tags:'money&paying', loc:'ContentCategories.PaymentSystems'},
    17:{def:'Banks', tags:'money&paying', loc:'ContentCategories.Banks'},
    18:{def:'Discrimination', tags:'violence; 18+', loc:'ContentCategories.Discrimination'},
    19:{def:'Discontent', tags:'violence; 18+', loc:'ContentCategories.Discontent'},
    20:{def:'OnlineShopWithOwnPaymentSystem', tags:'shopping; money&paying', loc:'ContentCategories.OnlineShopWithOwnPaymentSystem'},
    21:{def:'PoliceDecision', tags:'18+; violence; law', loc:'ContentCategories.PoliceDecision'},
    22:{def:'SoftwareAudioVideo', tags:'entertainment; media sharing', loc:'ContentCategories.SoftwareAudioVideo'},
    27:{def:'GamblingLotteriesSweepstakes', tags:'gaming - hazard', loc:'ContentCategories.GamblingLotteriesSweepstakes'},
    28:{def:'InternetCommunicationMedia', tags:'hobby&entertainment; online collaboration', loc:'ContentCategories.InternetCommunicationMedia'},
    34:{def:'ECommerce', tags:'money&paying', loc:'ContentCategories.ECommerce'},
    35:{def:'ComputerGames', tags:'gaming; hobby&entertainment', loc:'ContentCategories.ComputerGames'},
    36:{def:'Religions', tags:'society&law', loc:'ContentCategories.Religions'},
    37:{def:'News', tags:'hobby&entertainment', loc:'ContentCategories.News'},
    38:{def:'PornoAndErotic', tags:'sex&adult; 18+', loc:'ContentCategories.PornoAndErotic'},
    39:{def:'Nudism', tags:'sex&adult; 18+', loc:'ContentCategories.Nudism'},
    40:{def:'Lingerie', tags:'shopping', loc:'ContentCategories.Lingerie'},
    41:{def:'SexEducation', tags:'sex&adult; education; 18+', loc:'ContentCategories.SexEducation'},
    42:{def:'EighteenPlusDating', tags:'sex&adult; 18+; online collaboration', loc:'ContentCategories.EighteenPlusDating'},
    43:{def:'LGBT', tags:'sex&adult; 18+', loc:'ContentCategories.LGBT'},
    44:{def:'SexShops', tags:'sex&adult; 18+; shopping', loc:'ContentCategories.SexShops'},
    45:{def:'Narcotics', tags:'psychotropic&drug; health&medicine', loc:'ContentCategories.Narcotics'},
    46:{def:'Alcohol', tags:'drug; shopping', loc:'ContentCategories.Alcohol'},
    47:{def:'Tobacco', tags:'psychotropic&drug', loc:'ContentCategories.Tobacco'},
    48:{def:'CultureAndSociety', tags:'society&law; hobby&entertainment', loc:'ContentCategories.CultureAndSociety'},
    49:{def:'GovernmentPoliticsLaws', tags:'society&law', loc:'ContentCategories.GovernmentPoliticsLaws'},
    50:{def:'HomeAndFamily', tags:'hobby&entertainment; children', loc:'ContentCategories.HomeAndFamily'},
    51:{def:'Military', tags:'society&law', loc:'ContentCategories.Military'},
    52:{def:'RestaurantsCafeFood', tags:'hobby&entertainment; shopping', loc:'ContentCategories.RestaurantsCafeFood'},
    53:{def:'AstrologyAndEsoterica', tags:'hobby&entertainment', loc:'ContentCategories.AstrologyAndEsoterica'},
    54:{def:'Torrents', tags:'media sharing', loc:'ContentCategories.Torrents'},
    55:{def:'FileSharing', tags:'media sharing', loc:'ContentCategories.FileSharing'},
    56:{def:'AudioAndVideo', tags:'media sharing; hobby&entertainment', loc:'ContentCategories.AudioAndVideo'},
    57:{def:'InformationTechnologies', tags:'IT', loc:'ContentCategories.InformationTechnologies'},
    58:{def:'SearchEnginesAndServices', tags:'web services; IT', loc:'ContentCategories.SearchEnginesAndServices'},
    59:{def:'HostingAndDomains', tags:'web services; IT', loc:'ContentCategories.HostingAndDomains'},
    60:{def:'Ads', tags:'', loc:'ContentCategories.Ads'},
    61:{def:'BankSites', tags:'money&paying', loc:'ContentCategories.BankSites'},
    62:{def:'RentRealEstateServices', tags:'money&paying', loc:'ContentCategories.RentRealEstateServices'},
    65:{def:'SelfDamage', tags:'violence; 18+', loc:'ContentCategories.SelfDamage'},
    66:{def:'Blogs', tags:'online collaboration; hobby&entertainment', loc:'ContentCategories.Blogs'},
    67:{def:'DatingSites', tags:'online collaboration; hobby&entertainment', loc:'ContentCategories.DatingSites'},
    68:{def:'Education', tags:'education; hobby&entertainment', loc:'ContentCategories.Education'},
    69:{def:'SchoolsUniversities', tags:'education; children', loc:'ContentCategories.SchoolsUniversities'},
    70:{def:'BooksAndWriting', tags:'education; hobby&entertainment', loc:'ContentCategories.BooksAndWriting'},
    71:{def:'EducationPortalsKnowledgeBases', tags:'education', loc:'ContentCategories.EducationPortalsKnowledgeBases'},
    72:{def:'HobbyAndEntertainment', tags:'hobby&entertainment', loc:'ContentCategories.HobbyAndEntertainment'},
    73:{def:'FishingHunting', tags:'hobby&entertainment', loc:'ContentCategories.FishingHunting'},
    74:{def:'TravelTrips', tags:'hobby&entertainment', loc:'ContentCategories.TravelTrips'},
    75:{def:'TVAndRadio', tags:'hobby&entertainment', loc:'ContentCategories.TVAndRadio'},
    76:{def:'PetsAnimals', tags:'hobby&entertainment', loc:'ContentCategories.PetsAnimals'},
    77:{def:'Humor', tags:'hobby&entertainment', loc:'ContentCategories.Humor'},
    78:{def:'Music', tags:'hobby&entertainment; media sharing', loc:'ContentCategories.Music'},
    79:{def:'HealthAndBeauty', tags:'psychotropic&drug; health&medicine; hobby&entertainment', loc:'ContentCategories.HealthAndBeauty'},
    80:{def:'SportAndSportGames', tags:'hobby&entertainment; health&medicine', loc:'ContentCategories.SportAndSportGames'},
    81:{def:'Health', tags:'psychotropic&drug; health&medicine; hobby&entertainment', loc:'ContentCategories.Health'},
    82:{def:'FashionStyle', tags:'hobby&entertainment', loc:'ContentCategories.FashionStyle'},
    83:{def:'MedicalPharmacy', tags:'psychotropic&drug; health&medicine', loc:'ContentCategories.MedicalPharmacy'},
    84:{def:'Lotteries', tags:'gaming - hazard; hobby&entertainment', loc:'ContentCategories.Lotteries'},
    85:{def:'CasinoCardGames', tags:'gaming - hazard;  hobby&entertainment', loc:'ContentCategories.CasinoCardGames'},
    86:{def:'Betting', tags:'gaming - hazard; hobby&entertainment', loc:'ContentCategories.Betting'},
    87:{def:'HateAndDiscrimination', tags:'violence; 18+', loc:'ContentCategories.HateAndDiscrimination'},
    88:{def:'ExtremismRacism', tags:'violence; 18+', loc:'ContentCategories.ExtremismRacism'},
    89:{def:'Miscellaneous', tags:'', loc:'ContentCategories.Miscellaneous'},
    90:{def:'Anorexia', tags:'18+; health&medicine', loc:'ContentCategories.Anorexia'},
    91:{def:'Abortion', tags:'18+; health&medicine', loc:'ContentCategories.Abortion'},
    92:{def:'KidsInternet', tags:'hobby&entertainment; online collaboration; children; education', loc:'ContentCategories.KidsInternet'},
    93:{def:'InternetServices', tags:'web services; media sharing', loc:'ContentCategories.InternetServices'},
    94:{def:'LegislationRF', tags:'forbidden by law', loc:'ContentCategories.LegislationRF'},
    95:{def:'FederalLaw436RF', tags:'children; forbidden by law', loc:'ContentCategories.FederalLaw436RF'},
    96:{def:'FederalListOfExtremistsMatRF', tags:'forbidden by law; violence; 18+', loc:'ContentCategories.FederalListOfExtremistsMatRF'},
    97:{def:'RoskomnadzorListRF', tags:'forbidden by law', loc:'ContentCategories.RoskomnadzorListRF'},
    98:{def:'LegislationGlobal', tags:'forbidden by law', loc:'ContentCategories.LegislationGlobal'},
    113:{def:'UFOAdware', tags:'', loc:'ContentCategories.UFOAdware'},
    114:{def:'UFOOther', tags:'', loc:'ContentCategories.UFOOther'},
    130:{def:'Wargaming', tags:'gaming; hobby&entertainment', loc:'ContentCategories.Wargaming'},
    137:{def:'KPSNWhiteList', tags:'', loc:'ContentCategories.KPSNWhiteList'},
    138:{def:'KPSNBlackList', tags:'', loc:'ContentCategories.KPSNBlackList'}
}

function toViewWcRules(data) {
    let wcRules = [];
    data.CertificateSearchPatterns.KLPRSS_Val[0].forEach(function(item) {
        wcRules.push({
            RuleType:enums.TsWcRuleTypeEnum.Sert,
            Enable: item.Enable.KLPRSS_Val,
            Type:enums.TmExcludeTypeEnum.Deny,
            Name: '',
            UrlPattern:'',
            Descr:item.Description.KLPRSS_Val,
            SertMode:item.Mode.KLPRSS_Val,
            SertPattern:item.Pattern.KLPRSS_Val
        });
    });

    data.UrlRules.KLPRSS_Val[0].forEach(function(item) {
        wcRules.push({
            RuleType:enums.TsWcRuleTypeEnum.Url,
            Enable: item.Enable.KLPRSS_Val,
            Type:item.Type.KLPRSS_Val,
            Name: item.Name.KLPRSS_Val,
            UrlPattern:item.UrlPattern.KLPRSS_Val,
            Descr:'',
            SertMode:1,
            SertPattern:''
        });
    });

    return {WcRules:wcRules};
}

function toViewCategories(data) {
    let uiFields = {
        EnableOther:false,
        EnableNotAVirus:false,
        EnableAdverts:false,
        uiContentCats:[]
    };

    const contentCats = data.ContentCategories.KLPRSS_Val[0];
    for(let item of contentCats){
        let oneCat = {Allowed:item.Allowed.KLPRSS_Val, Type: item.CategoryType.KLPRSS_Val, Name:item.Name.KLPRSS_Val};
        if(ContentCategoryEnum[oneCat.Type]!==undefined){
            if(ContentCategoryEnum[oneCat.Type].def==='Other'){
                uiFields.EnableOther = oneCat.Allowed;
                continue;
            }
            if(ContentCategoryEnum[oneCat.Type].def==='UFOOther'){
                uiFields.EnableNotAVirus = oneCat.Allowed;
                continue;
            }
            if(ContentCategoryEnum[oneCat.Type].def==='UFOAdware'){
                uiFields.EnableAdverts = oneCat.Allowed;
                continue;
            }
            oneCat.Name = ContentCategoryEnum[oneCat.Type].loc;
            oneCat.Tags = ContentCategoryEnum[oneCat.Type].tags;
        }
        uiFields.uiContentCats.push(oneCat);
    }

    return uiFields;
}

function toRowWcRules(changedData) {
    let urlRules = [];
    let sertRules = [];

    changedData.uiFields.WcRules.forEach(function(item) {
        if(item.RuleType===enums.TsWcRuleTypeEnum.Url){
            urlRules.push({
                Enable: {KLPRSS_Mnd:false, KLPRSS_Val:item.Enable},
                Name: {KLPRSS_Mnd:false, KLPRSS_Val:item.Name},
                Type: {KLPRSS_Mnd:false, KLPRSS_Val:parseInt(item.Type)},
                UrlPattern: {KLPRSS_Mnd:false, KLPRSS_Val:item.UrlPattern},
                __VersionInfo: {KLPRSS_Mnd:false, KLPRSS_Val:[1,0]}
            });
        }
        else if(item.RuleType===enums.TsWcRuleTypeEnum.Sert){
            sertRules.push({
                Description: {KLPRSS_Mnd:false, KLPRSS_Val:item.Descr},
                Enable: {KLPRSS_Mnd:false, KLPRSS_Val:item.Enable},
                Mode: {KLPRSS_Mnd:false, KLPRSS_Val:item.SertMode},
                Pattern: {KLPRSS_Mnd:false, KLPRSS_Val:item.SertPattern},
                __VersionInfo: {KLPRSS_Mnd:false, KLPRSS_Val:[1,0]}
            });
        }
    });

    delete changedData.uiFields;
    changedData.CertificateSearchPatterns.KLPRSS_Val[0] = sertRules;
    changedData.UrlRules.KLPRSS_Val[0] = urlRules;
    return changedData;
}

function toRowLocalWcRules(changedData) {
    let urlRules = [];
    let sertRules = [];

    changedData.uiFields.WcRules.forEach(function(item) {
        if(item.RuleType===enums.TsWcRuleTypeEnum.Url){
            urlRules.push({
                Enable: item.Enable,
                Name: item.Name,
                Type: parseInt(item.Type),
                UrlPattern: item.UrlPattern,
                __VersionInfo:[1,0]
            });
        }
        else if(item.RuleType===enums.TsWcRuleTypeEnum.Sert){
            sertRules.push({
                Description: item.Descr,
                Enable: item.Enable,
                Mode: item.SertMode,
                Pattern: item.SertPattern,
                __VersionInfo: [1,0]
            });
        }
    });

    return {
        CertificateSearchPatterns:sertRules,
        UrlRules: urlRules,
        UseCertificates: changedData.UseCertificates.KLPRSS_Val[0],
        UseUrlRules: changedData.UseUrlRules.KLPRSS_Val[0]
    };
}

function toRowCategories(changedData) {
    changedData.ContentCategories.KLPRSS_Val[0].forEach(function(item) {
        const cType = item.CategoryType.KLPRSS_Val;
        const cat_helper = (ContentCategoryEnum[cType]!==undefined) ? ContentCategoryEnum[cType] : {def:''};
        if(cat_helper.def==='Other'){
            item.Allowed.KLPRSS_Val = changedData.uiFields.EnableOther;
        }
        else if(cat_helper.def==='UFOOther'){
            item.Allowed.KLPRSS_Val = changedData.uiFields.EnableNotAVirus;
        }
        else if(cat_helper.def==='UFOAdware'){
            item.Allowed.KLPRSS_Val = changedData.uiFields.EnableAdverts;
        }
        else{
            let uiItem = changedData.uiFields.uiContentCats.filter(function(x){
                return x.Type ===  cType;
            })
            if( uiItem.length=== 1){
                item.Allowed.KLPRSS_Val = uiItem[0].Allowed;
            }
        }
    });

    delete changedData.uiFields;
    return changedData;
}

function toRowLocalCategories(changedData) {
    let cats = [];
    changedData.ContentCategories.KLPRSS_Val[0].forEach(function(item) {
        let cat = {
            Allowed : item.Allowed.KLPRSS_Val,
            CategoryType: item.CategoryType.KLPRSS_Val,
            Description: item.Description.KLPRSS_Val,
            Name: item.Name.KLPRSS_Val,
            __VersionInfo: item.__VersionInfo.KLPRSS_Val
        };
        const cType = cat.CategoryType;
        const cat_helper = (ContentCategoryEnum[cType]!==undefined) ? ContentCategoryEnum[cType] : {def:''};
        if(cat_helper.def==='Other'){
            cat.Allowed = changedData.uiFields.EnableOther;
        }
        else if(cat_helper.def==='UFOOther'){
            cat.Allowed = changedData.uiFields.EnableNotAVirus;
        }
        else if(cat_helper.def==='UFOAdware'){
            cat.Allowed = changedData.uiFields.EnableAdverts;
        }
        else{
            let uiItem = changedData.uiFields.uiContentCats.filter(function(x){
                return x.Type ===  cType;
            })
            if( uiItem.length=== 1){
                cat.Allowed.KLPRSS_Val = uiItem[0].Allowed;
            }
        }
        cats.push(cat);
    });

    delete changedData.uiFields;
    return {
        ContentCategories: cats,
        UseContentCategories: changedData.UseContentCategories.KLPRSS_Val[0]
    };
}

let FixLocalSettings = (Settings) => {
    let patterns = [];
    Settings.CertificateSearchPatterns.forEach(function(item) {
        const newItem = {
            Description : item.Description.KLPRSS_Val!==undefined ? item.Description.KLPRSS_Val : item.Description,
            Enable : item.Enable.KLPRSS_Val!==undefined ? item.Enable.KLPRSS_Val : item.Enable,
            Mode : item.Mode.KLPRSS_Val!==undefined ? item.Mode.KLPRSS_Val : item.Mode,
            Pattern : item.Pattern.KLPRSS_Val!==undefined ? item.Pattern.KLPRSS_Val : item.Pattern,
            __VersionInfo : item.__VersionInfo.KLPRSS_Val!==undefined ? item.__VersionInfo.KLPRSS_Val : item.__VersionInfo
        };
        patterns.push(newItem);
    });
    Settings.CertificateSearchPatterns = patterns;

    let categiories = [];
    Settings.ContentCategories.forEach(function(item) {
        const newItem = {
            Allowed : item.Allowed.KLPRSS_Val!==undefined ? item.Allowed.KLPRSS_Val : item.Allowed,
            CategoryType : item.CategoryType.KLPRSS_Val!==undefined ? item.CategoryType.KLPRSS_Val : item.CategoryType,
            Description : item.Description.KLPRSS_Val!==undefined ? item.Description.KLPRSS_Val : item.Description,
            Name : item.Name.KLPRSS_Val!==undefined ? item.Name.KLPRSS_Val : item.Name,
            __VersionInfo : item.__VersionInfo.KLPRSS_Val!==undefined ? item.__VersionInfo.KLPRSS_Val : item.__VersionInfo
        };
        categiories.push(newItem);
    });
    Settings.ContentCategories = categiories;
    return Settings;
}

module.exports = {
    toViewWcRules,
    toViewCategories,
    toRowWcRules,
    toRowLocalWcRules,
    toRowCategories,
    toRowLocalCategories,
    FixLocalSettings
}