// task's defaults
const VerdictTypeEnum = {
    Undefined: 1,
    Virware: 2,
    Trojware: 3,
    Malware: 4,
    Adware: 5,
    Pornware: 6,
    Riskware: 7,
    Vulnerability:8
};

const  OdsActionType = {
    Cure: 1,
    Remove: 2,
    Recommended: 3,
    Report: 4,
    Quarantine: 5,
    RunExec	: 6,
    Skip: 7,
    Postpone: 8
};

const getOdsAdvanceAction = (verdict, first, second) => {
    return {
        Actions: [{
            DetectCertainty:0,
            FirstAction: {ActionType:first, __VersionInfo:[1, 0] },
            SecondAction:{ActionType:second, __VersionInfo:[1, 0] },
            __VersionInfo:[1, 0]
        }],
        Verdict: verdict,
        __VersionInfo:[1, 0]
    };
}

const defaultOdsScanSettings = () => {
    return {
        AdvancedActions: [],
        DeleteArchives: false,
        DontScanProcessMemoryRegions:false,
        ExcludeMasks: [],
        ExcludeThreats: [],
        InfectedFirstAction: {ActionType: 3, __VersionInfo: [1, 0]},
        InfectedSecondAction: {ActionType: 3, __VersionInfo: [1, 0]},
        ScanArchived: true,
        ScanArchivedMode: 1,
        ScanExtensionMasks: [],
        ScanHSMOptions: { ActionType: 2,  ScanNoRecall: false, ScanRecentlyTouched: true, TouchedInDays: 15,  __VersionInfo: [1, 0] },
        ScanMailBases: false,
        ScanMailBasesMode: 1,
        ScanObjects: true,
        ScanOle: true,
        ScanOleMode: 1,
        ScanOnlyNewAndChangedFiles: false,
        ScanPacked: true,
        ScanPackedMode: 1,
        ScanPlainMail: false,
        ScanPlainMailMode: 1,
        ScanSectors: true,
        ScanSfxArchived: true,
        ScanSfxArchivedMode: 1,
        ScanStreams: true,
        ScanSubfiles: true,
        ScanSubfolders: true,
        ScanType: 1,
        SizeLimit: 8388608,
        SuspiciousFirstAction: {ActionType: 3, __VersionInfo: [1, 0]},
        SuspiciousSecondAction: {ActionType: 3, __VersionInfo: [1, 0]},
        TimeLimit: 60,
        UseAdvancedActions: false,
        UseExcludeMasks: false,
        UseExcludeThreats: false,
        UseIChecker: true,
        UseISwift: true,
        UseMicrosoftSignChecking: false,
        UseSizeLimit: false,
        UseTimeLimit: false,
        __VersionInfo: [1, 5]
    }
}

const defaultOdsAdvanceActions = () => {
    return [
        getOdsAdvanceAction(VerdictTypeEnum.Undefined, OdsActionType.Cure, OdsActionType.Remove),
        getOdsAdvanceAction(VerdictTypeEnum.Virware, OdsActionType.Cure, OdsActionType.Remove),
        getOdsAdvanceAction(VerdictTypeEnum.Trojware, OdsActionType.Remove, OdsActionType.Report),
        getOdsAdvanceAction(VerdictTypeEnum.Malware, OdsActionType.Remove, OdsActionType.Report),
        getOdsAdvanceAction(VerdictTypeEnum.Adware, OdsActionType.Remove, OdsActionType.Report),
        getOdsAdvanceAction(VerdictTypeEnum.Pornware, OdsActionType.Remove, OdsActionType.Report),
        getOdsAdvanceAction(VerdictTypeEnum.Riskware, OdsActionType.Quarantine, OdsActionType.Remove),
    ];
}

function defaultIcapScanScope() {
    return {
        AdvancedActions: [],
        ExcludeMasks: [],
        ExcludeThreats: [],
        InfectedFirstAction: {ActionType: 3, __VersionInfo: [1, 0]},
        InfectedSecondAction: {ActionType: 3, __VersionInfo: [1, 0]},
        ScanArchived: true,
        ScanExtensionMasks: [],
        ScanMailBases: false,
        ScanOle: true,
        ScanPacked: true,
        ScanPlainMail: false,
        ScanSfxArchived: true,
        ScanType: 1,
        SizeLimit: 8388608,
        SuspiciousFirstAction: {ActionType: 3, __VersionInfo: [1, 0]},
        SuspiciousSecondAction: {ActionType: 3, __VersionInfo: [1, 0]},
        TimeLimit: 60,
        UseAdvancedActions: false,
        UseExcludeMasks: false,
        UseExcludeThreats: false,
        UseSizeLimit: false,
        UseTimeLimit: false,
        __VersionInfo: [2, 0]
    }
}

function defaultCheckFimScanArea() {
    return {
        Enable:true,
        Path:'',
        UseSubFolders:true,
        __VersionInfo: [1, 0]
    }
}

function defaultNasacExclude() {
    return {
        Enable:true,
        IpAddresses :[],
        PathMasks:[],
        UseIpAddress:false,
        UsePathMask:false,
        UseUserSid:false,
        UserSids:[],
        __VersionInfo: [1, 0]
    }
}

module.exports = {
    defaultOdsScanSettings,
    defaultOdsAdvanceActions,
    defaultIcapScanScope,
    defaultCheckFimScanArea,
    defaultNasacExclude
}